package de.cliffbreak.core.classes;

import org.bukkit.Location;
import org.bukkit.block.Sign;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.net.InetSocketAddress;
import java.net.Socket;

public class StatusSign {

    private Location location;
    private Sign sign;
    private String name, host;
    private int port;

    public StatusSign(Location location, String host, int port, String name) {
        this.location = location;
        this.sign = (Sign) location.getBlock().getState();
        this.host = host;
        this.port = port;
        this.name = name;
    }

    public void update() {
        try {
            Socket socket = new Socket();
            socket.connect(new InetSocketAddress(this.host, this.port), 500);
            socket.setSoTimeout(500);

            DataOutputStream out = new DataOutputStream(socket.getOutputStream());
            DataInputStream in = new DataInputStream(socket.getInputStream());

            out.write(0xFE);

            StringBuilder str = new StringBuilder();

            int b;
            while ((b = in.read()) != -1) {
                if (b != 0 && b > 16 && b != 255 && b != 23 && b != 24) {
                    str.append((char) b);
                }
            }

            String[] data = str.toString().split("§");
            //String motd = data[0];
            int onlinePlayers = Integer.parseInt(data[1]);
            int maxPlayers = Integer.parseInt(data[2]);

            sign.setLine(0, "§2 ▒▒▒▒▒▒▒▒");
            sign.setLine(1, "§b§l§o" + this.name.substring(0, 1).toUpperCase() + this.name.substring(1));
            sign.setLine(2, "§f" + onlinePlayers + "§a/§f" + maxPlayers);
            sign.setLine(3, "§2 ▒▒▒▒▒▒▒▒");

            sign.update();
            socket.close();
        } catch (Exception e) {
            sign.setLine(0, "§4 ▒▒▒▒▒▒▒▒");
            sign.setLine(1, "§b§l§o" + this.name.substring(0, 1).toUpperCase() + this.name.substring(1));
            sign.setLine(2, "§c§lOFFLINE");
            sign.setLine(3, "§4 ▒▒▒▒▒▒▒▒");
            sign.update();
        }

    }

    public Location getLocation() {
        return location;
    }

    public String getName() {
        return name;
    }

    public String getHost() {
        return host;
    }

    public int getPort() {
        return port;
    }
}
