package de.cliffbreak.core.commands;

import de.cliffbreak.core.CliffbreakCore;
import de.cliffbreak.core.classes.StatusSign;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.data.type.Sign;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.io.IOException;
import java.util.*;

public class CommandSign implements CommandExecutor {
    private CliffbreakCore plugin;

    public CommandSign(CliffbreakCore plugin) {
        this.plugin = plugin;
    }

    @Override
    public boolean onCommand(CommandSender commandSender, Command command, String s, String[] args) {
        if (commandSender instanceof Player) {
            Player p = (Player) commandSender;
            if (!p.hasPermission("cliffbreak.command.sign")) {
                p.sendMessage("§cNope");
                return true;
            }
            if (args.length > 0 && args[0].equalsIgnoreCase("add")) {
                if (args.length < 4) {
                    p.sendMessage("§c/sign add <host> <port> <name>");
                    return true;
                }

                String host = args[1];
                int port = Integer.parseInt(args[2]);
                String name = args[3];

                Set<Material> set = new HashSet<Material>();
                set.add(Material.AIR);
                Block block = p.getTargetBlock(set, 10);

                if (block == null || (block.getState() instanceof Sign)) {
                    p.sendMessage("§cBitte schaue auf ein Schild!");
                    return true;
                }

                StatusSign statusSign = new StatusSign(block.getLocation(), host, port, name);
                saveSign(statusSign, p);
                plugin.statusSigns.add(statusSign);
            }
        }
        return true;
    }

    @SuppressWarnings("unchecked")
    private void saveSign(StatusSign statusSign, Player p) {
        List<Object> signs;
        if (plugin.cfg.get("Signs") == null)
            signs = new ArrayList<Object>();
        else
            signs = (List<Object>) plugin.cfg.get("Signs");

        Map<String, Object> sign = new HashMap<String, Object>();
        sign.put("host", statusSign.getHost());
        sign.put("port", statusSign.getPort());
        sign.put("name", statusSign.getName());
        Map<String, Object> location = new HashMap<String, Object>();
        location.put("world", statusSign.getLocation().getWorld().getName());
        location.put("x", statusSign.getLocation().getBlockX());
        location.put("y", statusSign.getLocation().getBlockY());
        location.put("z", statusSign.getLocation().getBlockZ());

        sign.put("location", location);
        signs.add(sign);
        plugin.cfg.set("Signs", signs);

        try {
            plugin.cfg.save(plugin.cfgFile);
            p.sendMessage("§aDas §lSchild §r§awurde erfolgreich erstellt.");
        } catch (IOException e) {
            p.sendMessage("§cDas §lSchild §r§cwurde NICHT erstellt.");
            e.printStackTrace();
        }
    }
}
